<template>
  <div
    data-component-group="lang"
    data-component="dropdown"
  >
    <v-menu
      v-model="isOn"
      bottom
      offset-y
      transition="slide-y-transition"
      nudge-bottom="10"
      :close-on-click="true"
      :close-on-content-click="false"
    >
      <v-btn
        slot="activator"
        class="purple trigger select-lang"
        :color="isOn ? 'primary' : 'secondary'"
        dark
        small
        :round="true"
        :class="getTriggerClass()"
        @click="toggle()"
      >
        {{ $t('components.lang_dropdown.title') }}
        <v-icon>
          keyboard_arrow_down
        </v-icon>
      </v-btn>
      <v-list>
        <v-list-tile
          v-for="locale in locales"
          :key="locale.code"
          :value="locale"
          color="secondary"
          :class="getLangClass(locale)"
          @click="selectLocale(locale.code, true)"
        >
          <v-list-tile-title>
            {{ locale.label }}
          </v-list-tile-title>
        </v-list-tile>
      </v-list>
    </v-menu>
  </div>
</template>

<script>
  import locales from '../../locales/locales.json';

  export default {
    data() {
      return {
        locales: [...locales],
        isOn: false,
      };
    },
    mounted() {
      const { locale } = this.$store.state;
      const { language } = locale;

      this.selectLocale(language);
    },
    methods: {
      toggle() {
        this.isOn = !this.isOn;
      },
      selectLocale(locale, shouldDispatch = false) {
        this.setSelectedLocale(locale);
        this.$i18n.locale = locale;

        if (shouldDispatch) {
          this.setLocale(locale);
        }
      },
      setSelectedLocale(locale) {
        this.locales = this.locales.map(lang => ({
          ...lang,
          isSelected: lang.code === locale,
        }));
      },
      setLocale(locale) {
        this.$store.dispatch('locale/setLanguage', locale);
      },
      getTriggerClass() {
        return {
          active: this.isOn,
        };
      },
      getLangClass(lang) {
        return {
          'active-lang': lang.isSelected,
        };
      },
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../assets/stylus/theme.styl';

  [data-component-group="lang"] {
    &[data-component="dropdown"] {
      .trigger.select-lang {
        &:not(.active) {
          .v-icon {
            transform: rotate(0deg);
            transition: all 0.15s ease-in-out;
          }
        }

        &.active {
          background-color: $colors.primary;

          .v-icon {
            transform: rotate(180deg);
            transition: all 0.15s ease-in-out;
          }
        }

        @media (max-width: $grid-breakpoints.md) {
          font-size: 12px;
        }
      }
    }
  }

  .v-list__tile__title {
    color: $colors.secondary
  }

  .active-lang {
    background-color: $colors.grey.lighten-1;

    .v-list__tile__title {
      color: $colors.shades.white;
    }
  }
</style>
